searchNodes=[{"doc":"Represents the arguments to a calculation being filtered on","ref":"AshPhoenix.FilterForm.Arguments.html","title":"AshPhoenix.FilterForm.Arguments","type":"module"},{"doc":"","ref":"AshPhoenix.FilterForm.Arguments.html#errors/2","title":"AshPhoenix.FilterForm.Arguments.errors/2","type":"function"},{"doc":"","ref":"AshPhoenix.FilterForm.Arguments.html#new/2","title":"AshPhoenix.FilterForm.Arguments.new/2","type":"function"},{"doc":"","ref":"AshPhoenix.FilterForm.Arguments.html#validate_arguments/2","title":"AshPhoenix.FilterForm.Arguments.validate_arguments/2","type":"function"},{"doc":"A module to help you create complex forms that generate Ash filters. # Create a FilterForm filter_form = AshPhoenix.FilterForm . new ( MyApp.Payroll.Employee ) FilterForm's comprise 2 concepts, predicates and groups. Predicates are the simple boolean expressions you can use to build a query ( name == &quot;Joe&quot; ), and groups can be used to group predicates and more groups together. Groups can apply and or or operators to its nested components. # Add a predicate to the root of the form (which is itself a group) filter_form = AshPhoenix . add_predicate ( filter_form , :some_field , :eq , &quot;Some Value&quot; ) # Add a group and another predicate to that group { filter_form , group_id } = AshPhoenix . add_group ( filter_form , operator : :or , return_id? : true ) filter_form = AshPhoenix . add_predicate ( filter_form , :another , :eq , &quot;Other&quot; , to : group_id ) validate/1 is used to merge the submitted form params into the filter form, and one of the provided filter functions to apply the filter as a query, or generate an expression map, depending on your requirements: filter_form = AshPhoenix . validate ( socket . assigns . filter_form , params ) # Generate a query and pass it to the Api query = AshPhoenix.FilterForm . filter! ( MyApp.Payroll.Employee , filter_form ) filtered_employees = MyApp.Payroll . read! ( query ) # Or use one of the other filter functions AshPhoenix.FilterForm . to_filter_expression ( filter_form ) AshPhoenix.FilterForm . to_filter_map ( filter_form ) LiveView Example You can build a form and handle adding and removing nested groups and predicates with the following: alias MyApp.Payroll.Employee @impl true def render ( assigns ) do ~H&quot;&quot;&quot; &lt;.simple_form :let={filter_form} for={@filter_form} phx-change=&quot;filter_validate&quot; phx-submit=&quot;filter_submit&quot; &gt; &lt;.filter_form_component component={filter_form} /&gt; &lt;:actions&gt; &lt;.button&gt;Submit&lt;/.button&gt; &lt;/:actions&gt; &lt;/.simple_form&gt; &lt;.table id=&quot;employees&quot; rows={@employees}&gt; &lt;:col :let={employee} label=&quot;Payroll ID&quot;&gt;&lt;%= employee.employee_id %&gt;&lt;/:col&gt; &lt;:col :let={employee} label=&quot;Name&quot;&gt;&lt;%= employee.name %&gt;&lt;/:col&gt; &lt;:col :let={employee} label=&quot;Position&quot;&gt;&lt;%= employee.position %&gt;&lt;/:col&gt; &lt;/.table&gt; &quot;&quot;&quot; end attr :component , :map , required : true , doc : &quot;Could be a FilterForm (group) or a Predicate&quot; defp filter_form_component ( %{ component : %{ source : % AshPhoenix.FilterForm { } } } = assigns ) do ~H&quot;&quot;&quot; &lt;div class=&quot;border-gray-50 border-8 p-4 rounded-xl mt-4&quot;&gt; &lt;div class=&quot;flex flex-row justify-between&quot;&gt; &lt;div class=&quot;flex flex-row gap-2 items-center&quot;&gt;Filter&lt;/div&gt; &lt;div class=&quot;flex flex-row gap-2 items-center&quot;&gt; &lt;.input type=&quot;select&quot; field={@component[:operator]} options={[&quot;and&quot;, &quot;or&quot;]} /&gt; &lt;.button phx-click=&quot;add_filter_group&quot; phx-value-component-id={@component.id} type=&quot;button&quot;&gt; Add Group &lt;/.button&gt; &lt;.button phx-click=&quot;add_filter_predicate&quot; phx-value-component-id={@component.id} type=&quot;button&quot; &gt; Add Predicate &lt;/.button&gt; &lt;.button phx-click=&quot;remove_filter_component&quot; phx-value-component-id={@component.id} type=&quot;button&quot; &gt; Remove Group &lt;/.button&gt; &lt;/div&gt; &lt;/div&gt; &lt;.inputs_for :let={component} field={@component[:components]}&gt; &lt;.filter_form_component component={component} /&gt; &lt;/.inputs_for&gt; &lt;/div&gt; &quot;&quot;&quot; end defp filter_form_component ( %{ component : %{ source : % AshPhoenix.FilterForm.Predicate { } } } = assigns ) do ~H&quot;&quot;&quot; &lt;div class=&quot;flex flex-row gap-2 mt-4&quot;&gt; &lt;.input type=&quot;select&quot; options={AshPhoenix.FilterForm.fields(Employee)} field={@component[:field]} /&gt; &lt;.input type=&quot;select&quot; options={AshPhoenix.FilterForm.predicates(Employee)} field={@component[:operator]} /&gt; &lt;.input field={@component[:value]} /&gt; &lt;.button phx-click=&quot;remove_filter_component&quot; phx-value-component-id={@component.id} type=&quot;button&quot; &gt; Remove &lt;/.button&gt; &lt;/div&gt; &quot;&quot;&quot; end @impl true def mount ( _params , _session , socket ) do socket = socket |&gt; assign ( :filter_form , AshPhoenix.FilterForm . new ( Employee ) ) |&gt; assign ( :employees , Employee . read_all! ( ) ) { :ok , socket } end @impl true def handle_event ( &quot;filter_validate&quot; , %{ &quot;filter&quot; =&gt; params } , socket ) do { :noreply , assign ( socket , filter_form : AshPhoenix.FilterForm . validate ( socket . assigns . filter_form , params ) ) } end def handle_event ( &quot;filter_submit&quot; , %{ &quot;filter&quot; =&gt; params } , socket ) do filter_form = AshPhoenix.FilterForm . validate ( socket . assigns . filter_form , params ) case AshPhoenix.FilterForm . filter ( Employee , filter_form ) do { :ok , query } -&gt; { :noreply , socket |&gt; assign ( :employees , Employee . read_all! ( query : query ) ) |&gt; assign ( :filter_form , filter_form ) } { :error , filter_form } -&gt; { :noreply , assign ( socket , filter_form : filter_form ) } end end def handle_event ( &quot;remove_filter_component&quot; , %{ &quot;component-id&quot; =&gt; component_id } , socket ) do { :noreply , assign ( socket , filter_form : AshPhoenix.FilterForm . remove_component ( socket . assigns . filter_form , component_id ) ) } end def handle_event ( &quot;add_filter_group&quot; , %{ &quot;component-id&quot; =&gt; component_id } , socket ) do { :noreply , assign ( socket , filter_form : AshPhoenix.FilterForm . add_group ( socket . assigns . filter_form , to : component_id ) ) } end def handle_event ( &quot;add_filter_predicate&quot; , %{ &quot;component-id&quot; =&gt; component_id } , socket ) do { :noreply , assign ( socket , filter_form : AshPhoenix.FilterForm . add_predicate ( socket . assigns . filter_form , :name , :contains , nil , to : component_id ) ) } end","ref":"AshPhoenix.FilterForm.html","title":"AshPhoenix.FilterForm","type":"module"},{"doc":"Add a group to the filter. A group can contain predicates and other groups, allowing you to build quite complex nested filters. Options: :to ( String.t/0 ) - The nested group id to add the group to. :operator - The operator that the group should have internally. Valid values are :and, :or The default value is :and . :return_id? ( boolean/0 ) - If set to true , the function returns {form, predicate_id} The default value is false .","ref":"AshPhoenix.FilterForm.html#add_group/2","title":"AshPhoenix.FilterForm.add_group/2","type":"function"},{"doc":"Add a predicate to the filter. Options: :to ( String.t/0 ) - The group id to add the predicate to. If not set, will be added to the top level group. :return_id? ( boolean/0 ) - If set to true , the function returns {form, predicate_id} The default value is false . :path - The relationship path to apply the predicate to","ref":"AshPhoenix.FilterForm.html#add_predicate/5","title":"AshPhoenix.FilterForm.add_predicate/5","type":"function"},{"doc":"Returns a flat list of all errors on all predicates in the filter.","ref":"AshPhoenix.FilterForm.html#errors/2","title":"AshPhoenix.FilterForm.errors/2","type":"function"},{"doc":"Returns the list of available fields, which may be attributes, calculations, or aggregates.","ref":"AshPhoenix.FilterForm.html#fields/1","title":"AshPhoenix.FilterForm.fields/1","type":"function"},{"doc":"Same as filter/2 but raises on errors.","ref":"AshPhoenix.FilterForm.html#filter!/2","title":"AshPhoenix.FilterForm.filter!/2","type":"function"},{"doc":"Converts the form into a filter, and filters the provided query or resource with that filter.","ref":"AshPhoenix.FilterForm.html#filter/2","title":"AshPhoenix.FilterForm.filter/2","type":"function"},{"doc":"Create a new filter form. Options: :params ( term/0 ) - Initial parameters to create the form with The default value is %{} . :as ( String.t/0 ) - Set the parameter name for the form. The default value is &quot;filter&quot; . :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the predicate and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :remove_empty_groups? ( boolean/0 ) - If true (the default), then any time a group would be made empty by removing a group or predicate, it is removed instead. An empty form can still be added, this only affects a group if its last component is removed. The default value is false .","ref":"AshPhoenix.FilterForm.html#new/2","title":"AshPhoenix.FilterForm.new/2","type":"function"},{"doc":"Returns the minimal set of params (at the moment just strips ids) for use in a query string.","ref":"AshPhoenix.FilterForm.html#params_for_query/1","title":"AshPhoenix.FilterForm.params_for_query/1","type":"function"},{"doc":"Returns the list of available predicates for the given resource, which may be functions or operators.","ref":"AshPhoenix.FilterForm.html#predicates/1","title":"AshPhoenix.FilterForm.predicates/1","type":"function"},{"doc":"Removes the group or predicate with the given id","ref":"AshPhoenix.FilterForm.html#remove_component/2","title":"AshPhoenix.FilterForm.remove_component/2","type":"function"},{"doc":"Remove the group with the given id","ref":"AshPhoenix.FilterForm.html#remove_group/2","title":"AshPhoenix.FilterForm.remove_group/2","type":"function"},{"doc":"Remove the predicate with the given id","ref":"AshPhoenix.FilterForm.html#remove_predicate/2","title":"AshPhoenix.FilterForm.remove_predicate/2","type":"function"},{"doc":"","ref":"AshPhoenix.FilterForm.html#to_filter!/1","title":"AshPhoenix.FilterForm.to_filter!/1","type":"function"},{"doc":"Same as to_filter_expression/1 but raises on errors.","ref":"AshPhoenix.FilterForm.html#to_filter_expression!/1","title":"AshPhoenix.FilterForm.to_filter_expression!/1","type":"function"},{"doc":"Returns a filter expression that can be provided to Ash.Query.filter/2 To add this to a query, remember to use ^ , for example: filter = AshPhoenix.FilterForm . to_filter_expression ( form ) Ash.Query . filter ( MyApp.Post , ^ filter ) Alternatively, you can use the shorthand: filter/2 to apply the expression directly to a query.","ref":"AshPhoenix.FilterForm.html#to_filter_expression/1","title":"AshPhoenix.FilterForm.to_filter_expression/1","type":"function"},{"doc":"Returns a filter map that can be provided to Ash.Filter.parse This allows for things like saving a stored filter. Does not currently support parameterizing calculations or functions.","ref":"AshPhoenix.FilterForm.html#to_filter_map/1","title":"AshPhoenix.FilterForm.to_filter_map/1","type":"function"},{"doc":"Update the predicate with the given id","ref":"AshPhoenix.FilterForm.html#update_predicate/3","title":"AshPhoenix.FilterForm.update_predicate/3","type":"function"},{"doc":"Updates the filter with the provided input and validates it. At present, no validation actually occurs, but this will eventually be added. Passing reset_on_change?: false into opts will prevent predicates to reset the value and operator fields to nil if the predicate field changes.","ref":"AshPhoenix.FilterForm.html#validate/3","title":"AshPhoenix.FilterForm.validate/3","type":"function"},{"doc":"Represents an individual predicate appearing in a filter form. Predicates are grouped up in an AshPhoenix.FilterForm to create boolean filter statements.","ref":"AshPhoenix.FilterForm.Predicate.html","title":"AshPhoenix.FilterForm.Predicate","type":"module"},{"doc":"","ref":"AshPhoenix.FilterForm.Predicate.html#errors/2","title":"AshPhoenix.FilterForm.Predicate.errors/2","type":"function"},{"doc":"A module to allow you to fluidly use resources with Phoenix forms. Life cycle The general workflow is, with either LiveView or Phoenix forms: Create a form with AshPhoenix.Form Render the form with Phoenix.Component.form (or CoreComponents.simple_form ), or, if using Surface, &lt;Form&gt; To validate the form (e.g with phx-change for liveview), pass the submitted params to AshPhoenix.Form.validate/3 On form submission, pass the params to AshPhoenix.Form.submit/2 On success, use the result to redirect or assign. On failure, reassign the provided form. The following keys exist on the form to show where in the lifecycle you are: submitted_once? - If the form has ever been submitted. Useful for not showing any errors on the first attempt to fill out a form. just_submitted? - If the form has just been submitted and no validation has happened since. Useful for things like triggering a UI effect that should stop when the form is modified again. .changed? - If something about the form is different than it originally was. Note that in some cases this can yield a false positive, specifically if a nested form is removed and then a new one is added with the exact same values. .touched_forms - A MapSet containing all keys in the form that have been modified. When submitting a form, only these keys are included in the parameters. Working with related data If your resource action accepts related data, (for example a managed relationship argument, or an embedded resource attribute), you can use Phoenix's inputs_for for that field, but you must do one of two things: Tell AshPhoenix.Form to automatically derive this behavior from your action, for example: form = user |&gt; AshPhoenix.Form . for_update ( :update , api : MyApi , forms : [ auto? : true ] ] ) Explicitly configure the behavior of it using the forms option. See for_create/3 for more. For example: form = user |&gt; AshPhoenix.Form . for_update ( :update , api : MyApi , forms : [ profile : [ resource : MyApp.Profile , data : user . profile , create_action : :create , update_action : :update forms : [ emails : [ data : user . profile . emails , resource : MyApp.UserEmail , create_action : :create , update_action : :update ] ] ] ] ) LiveView AshPhoenix.Form (unlike ecto changeset based forms) expects to be reused throughout the lifecycle of the liveview. You can use Phoenix events to add and remove form entries and submit/2 to submit the form, like so: def render ( assigns ) do ~H&quot;&quot;&quot; &lt;.simple_form for={@form} phx-change=&quot;validate&quot; phx-submit=&quot;submit&quot;&gt; &lt;%!-- Attributes for the parent resource --%&gt; &lt;.input type=&quot;email&quot; label=&quot;Email&quot; field={@form[:email]} /&gt; &lt;%!-- Render nested forms for related data --%&gt; &lt;.inputs_for :let={item_form} field={@form[:items]}&gt; &lt;.input type=&quot;text&quot; label=&quot;Item&quot; field={item_form[:name]} /&gt; &lt;.input type=&quot;number&quot; label=&quot;Amount&quot; field={item_form[:amount]} /&gt; &lt;.button type=&quot;button&quot; phx-click=&quot;remove_form&quot; phx-value-path={item_form.name}&gt; Remove &lt;/.button&gt; &lt;/.inputs_for&gt; &lt;:actions&gt; &lt;.button type=&quot;button&quot; phx-click=&quot;add_form&quot; phx-value-path={@form[:items].name}&gt; Add Item &lt;/.button&gt; &lt;.button&gt;Save&lt;/.button&gt; &lt;/:actions&gt; &lt;/.simple_form&gt; &quot;&quot;&quot; end def mount ( _params , _session , socket ) do form = MyApp.Grocery.Order |&gt; AshPhoenix.Form . for_create ( :create , api : MyApp.Grocery , forms : [ items : [ type : :list , resource : MyApp.Grocery.Item , create_action : :create ] ] ) |&gt; AshPhoenix.Form . add_form ( [ :items ] ) |&gt; to_form ( ) { :ok , assign ( socket , form : form ) } end # In order to use the `add_form` and `remove_form` helpers, you # need to make sure that you are validating the form on change def handle_event ( &quot;validate&quot; , %{ &quot;form&quot; =&gt; params } , socket ) do form = AshPhoenix.Form . validate ( socket . assigns . form , params ) { :noreply , assign ( socket , form : form ) } end def handle_event ( &quot;submit&quot; , %{ &quot;form&quot; =&gt; params } , socket ) do case AshPhoenix.Form . submit ( socket . assigns . form , params : params ) do { :ok , order } -&gt; { :noreply , socket |&gt; put_flash ( :info , &quot;Saved order for \#{ order . email } !&quot; ) |&gt; push_navigate ( to : ~p&quot;/&quot; ) } { :error , form } -&gt; { :noreply , assign ( socket , form : form ) } end end def handle_event ( &quot;add_form&quot; , %{ &quot;path&quot; =&gt; path } , socket ) do form = AshPhoenix.Form . add_form ( socket . assigns . form , path ) { :noreply , assign ( socket , form : form ) } end def handle_event ( &quot;remove_form&quot; , %{ &quot;path&quot; =&gt; path } , socket ) do form = AshPhoenix.Form . remove_form ( socket . assigns . form , path ) { :noreply , assign ( socket , form : form ) } end","ref":"AshPhoenix.Form.html","title":"AshPhoenix.Form","type":"module"},{"doc":"Adds a new form at the provided path. Doing this requires that the form has a create_action and a resource configured. path can be one of two things: A list of atoms and integers that lead to a form in the forms option provided. [:posts, 0, :comments] to add a comment to the first post. The html name of the form, e.g form[posts][0][comments] to mimic the above If you pass parameters to this function, keep in mind that, unless they are string keyed in the same shape they might come from your form, then the result of params/1 will reflect that, i.e add_form(form, &quot;foo&quot;, %{bar: 10}) , could produce params like %{&quot;field&quot; =&gt; value, &quot;foo&quot; =&gt; [%{bar: 10}]} &quot;}. Notice how they are not string keyed as you would expect. However, once the form is changed (in liveview) and a call to validate/2 is made with that input, then the parameters would become what you'd expect. In this way, if you are using add_form with not string keys/values you may not be able to depend on the shape of the params map (which you should ideally not depend on anyway). :prepend ( boolean/0 ) - If specified, the form is placed at the beginning of the list instead of the end of the list The default value is false . :params ( term/0 ) - The initial parameters to add the form with. The default value is %{} . :validate? ( boolean/0 ) - Validates the new full form. The default value is true . :validate_opts ( term/0 ) - Options to pass to validate . Only used if validate? is set to true (the default) The default value is [] . :type - If type is set to :read , the form will be created for a read action. A hidden field will be set in the form called _form_type to track this information. Valid values are :read, :create, :update, :destroy The default value is :create . :data ( term/0 ) - The data to set backing the form. Generally you'd only want to do this if you are adding a form with type: :read additionally.","ref":"AshPhoenix.Form.html#add_form/3","title":"AshPhoenix.Form.add_form/3","type":"function"},{"doc":"A utility to get the list of arguments the action underlying the form accepts","ref":"AshPhoenix.Form.html#arguments/1","title":"AshPhoenix.Form.arguments/1","type":"function"},{"doc":"A utility to get the list of attributes the action underlying the form accepts","ref":"AshPhoenix.Form.html#attributes/1","title":"AshPhoenix.Form.attributes/1","type":"function"},{"doc":"Clears a given input's value on a form. Accepts a field (atom) or a list of fields (atoms) as a second argument.","ref":"AshPhoenix.Form.html#clear_value/2","title":"AshPhoenix.Form.clear_value/2","type":"function"},{"doc":"Returns the errors on the form. By default, only errors on the form being passed in (not nested forms) are provided. Use for_path to get errors for nested forms. :format - Values: - ` :raw ` - ` [ field : , { message , substitutions } } ] ` ( for translation ) - ` :simple ` - ` [ field : &quot;message w/ variables substituted&quot; ] ` - ` :plaintext ` - ` [ &quot;field: message w/ variables substituted&quot; ] ` Valid values are :simple, :raw, :plaintext The default value is :simple . :for_path ( term/0 ) - The path of the form you want errors for, either as a list or as a string, e.g [:comments, 0] or form[comments][0] Passing :all will cause this function to return a map of path to its errors, like so: %{[:comments, 0] =&gt; [body: &quot;is invalid&quot;], ...} The default value is [] .","ref":"AshPhoenix.Form.html#errors/2","title":"AshPhoenix.Form.errors/2","type":"function"},{"doc":"Calls the corresponding for_* function depending on the action type","ref":"AshPhoenix.Form.html#for_action/3","title":"AshPhoenix.Form.for_action/3","type":"function"},{"doc":"Creates a form corresponding to a create action on a resource. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. :exclude_fields_if_empty - These fields will be ignored if they are empty strings. This list of fields supports dead view forms. When a form is submitted from dead view empty fields are submitted as empty strings. This is problematic for fields that allow_nil or those that have default values. Any additional options will be passed to the underlying call to Ash.Changeset.for_create/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called. Nested Form Options To automatically determine the nested forms available for a given form, use forms: [auto?: true] . You can add additional nested forms by including them in the forms config alongside auto?: true . See the module documentation of AshPhoenix.Form.Auto for more information. If you want to do some manipulation of the auto forms, you can also call AshPhoenix.Form.Auto.auto/2 , and then manipulate the result and pass it to the forms option. To pass options, use auto?: [option1: :value] . See the documentation of AshPhoenix.Form.Auto for more. :type - The cardinality of the nested form - :list or :single . Valid values are :list, :single The default value is :single . :sparse? ( boolean/0 ) - If the nested form is sparse , the form won't expect all inputs for all forms to be present. Has no effect if the type is :single . Normally, if you leave some forms out of a list of nested forms, they are removed from the parameters passed to the action. For example, if you had a post with two comments [%Comment{id: 1}, %Comment{id: 2}] and you passed down params like comments[0][id]=1&amp;comments[1][text]=new_text , we would remove the second comment from the input parameters, resulting in the following being passed into the action: %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}]} . By setting it to sparse, you have to explicitly use remove_form for that removal to happen. So in the same scenario above, the parameters that would be sent would actually be %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}, %{&quot;id&quot; =&gt; 2}]} . One major difference with sparse? is that the form actually ignores the index provided, e.g comments[0]... , and instead uses the primary key e.g comments[0][id] to match which form is being updated. This prevents you from having to find the index of the specific item you want to update. Which could be very gnarly on deeply nested forms. If there is no primary key, or the primary key does not match anything, it is treated as a new form. REMEMBER: You need to use Phoenix.Components.inputs_for to render the nested forms, or manually add hidden inputs using hidden_inputs_for (or HiddenInputs if using Surface) for the id to be automatically placed into the form. :forms ( keyword/0 ) - Forms nested inside the current nesting level in all cases :for_type - What action types the form applies for. Leave blank for it to apply to all action types. Valid values are :read, :create, :update :merge? ( boolean/0 ) - When building parameters, this input will be merged with its parent input. This allows for combining multiple forms into a single input. The default value is false . :for ( atom/0 ) - When creating parameters for the action, the key that the forms should be gathered into. Defaults to the key used to configure the nested form. Ignored if merge? is true . :resource ( atom/0 ) - The resource of the nested forms. Unnecessary if you are providing the data key, and not adding additional forms to this path. :create_action ( atom/0 ) - The create action to use when building new forms. Only necessary if you want to use add_form/3 with this path. :update_action ( atom/0 ) - The update action to use when building forms for data. Only necessary if you supply the data key. :data ( term/0 ) - The current value or values that should have update forms built by default. You can also provide a single argument function that will return the data based on the data of the parent form. This is important for multiple nesting levels of :list type forms, because the data depends on which parent is being rendered.","ref":"AshPhoenix.Form.html#for_create/3","title":"AshPhoenix.Form.for_create/3","type":"function"},{"doc":"Creates a form corresponding to a destroy action on a record. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. :exclude_fields_if_empty - These fields will be ignored if they are empty strings. This list of fields supports dead view forms. When a form is submitted from dead view empty fields are submitted as empty strings. This is problematic for fields that allow_nil or those that have default values. Any additional options will be passed to the underlying call to Ash.Changeset.for_destroy/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.","ref":"AshPhoenix.Form.html#for_destroy/3","title":"AshPhoenix.Form.for_destroy/3","type":"function"},{"doc":"Creates a form corresponding to a read action on a resource. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. :exclude_fields_if_empty - These fields will be ignored if they are empty strings. This list of fields supports dead view forms. When a form is submitted from dead view empty fields are submitted as empty strings. This is problematic for fields that allow_nil or those that have default values. Any additional options will be passed to the underlying call to Ash.Query.for_read/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called. Keep in mind that the source of the form in this case is a query, not a changeset. This means that, very likely, you would not want to use nested forms here. However, it could make sense if you had a query argument that was an embedded resource, so the capability remains. Nested Form Options :type - The cardinality of the nested form - :list or :single . Valid values are :list, :single The default value is :single . :sparse? ( boolean/0 ) - If the nested form is sparse , the form won't expect all inputs for all forms to be present. Has no effect if the type is :single . Normally, if you leave some forms out of a list of nested forms, they are removed from the parameters passed to the action. For example, if you had a post with two comments [%Comment{id: 1}, %Comment{id: 2}] and you passed down params like comments[0][id]=1&amp;comments[1][text]=new_text , we would remove the second comment from the input parameters, resulting in the following being passed into the action: %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}]} . By setting it to sparse, you have to explicitly use remove_form for that removal to happen. So in the same scenario above, the parameters that would be sent would actually be %{&quot;comments&quot; =&gt; [%{&quot;id&quot; =&gt; 1, &quot;text&quot; =&gt; &quot;new&quot;}, %{&quot;id&quot; =&gt; 2}]} . One major difference with sparse? is that the form actually ignores the index provided, e.g comments[0]... , and instead uses the primary key e.g comments[0][id] to match which form is being updated. This prevents you from having to find the index of the specific item you want to update. Which could be very gnarly on deeply nested forms. If there is no primary key, or the primary key does not match anything, it is treated as a new form. REMEMBER: You need to use Phoenix.Components.inputs_for to render the nested forms, or manually add hidden inputs using hidden_inputs_for (or HiddenInputs if using Surface) for the id to be automatically placed into the form. :forms ( keyword/0 ) - Forms nested inside the current nesting level in all cases :for_type - What action types the form applies for. Leave blank for it to apply to all action types. Valid values are :read, :create, :update :merge? ( boolean/0 ) - When building parameters, this input will be merged with its parent input. This allows for combining multiple forms into a single input. The default value is false . :for ( atom/0 ) - When creating parameters for the action, the key that the forms should be gathered into. Defaults to the key used to configure the nested form. Ignored if merge? is true . :resource ( atom/0 ) - The resource of the nested forms. Unnecessary if you are providing the data key, and not adding additional forms to this path. :create_action ( atom/0 ) - The create action to use when building new forms. Only necessary if you want to use add_form/3 with this path. :update_action ( atom/0 ) - The update action to use when building forms for data. Only necessary if you supply the data key. :data ( term/0 ) - The current value or values that should have update forms built by default. You can also provide a single argument function that will return the data based on the data of the parent form. This is important for multiple nesting levels of :list type forms, because the data depends on which parent is being rendered.","ref":"AshPhoenix.Form.html#for_read/3","title":"AshPhoenix.Form.for_read/3","type":"function"},{"doc":"Creates a form corresponding to an update action on a record. Options: :forms ( keyword/0 ) - Nested form configurations. See for_create/3 &quot;Nested Form Options&quot; docs for more. :warn_on_unhandled_errors? ( boolean/0 ) - Warns on any errors that don't match the form pattern of {:field, &quot;message&quot;, [replacement: :vars]} or implement the AshPhoenix.FormData.Error protocol. The default value is true . :api ( atom/0 ) - The api module to use for form submission. If not set, calls to Form.submit/2 will fail :as ( String.t/0 ) - The name of the form in the submitted params. You will need to pull the form params out using this key. The default value is &quot;form&quot; . :id ( String.t/0 ) - The html id of the form. Defaults to the value of :as if provided, otherwise &quot;form&quot; :transform_errors ( term/0 ) - Allows for manual manipulation and transformation of errors. If possible, try to implement AshPhoenix.FormData.Error for the error (if it as a custom one, for example). If that isn't possible, you can provide this function which will get the changeset and the error, and should return a list of ash phoenix formatted errors, e.g [{field :: atom, message :: String.t(), substituations :: Keyword.t()}] :prepare_source ( term/0 ) - Takes a function over a changeset and runs it before calling the relevant changeset function. This can be used to do things like: set private argument values before the validations are run using Ash.Changeset.set_arguments/2 or Ash.Changeset.set_argument/3 set changeset context do any other pre-processing on the changeset :prepare_params - A function for pre-processing the form parameters before they are handled by the form. :transform_params - A function for post-processing the form parameters before they are used for changeset validation/submission. Use a 3 argument function to pattern match on the AshPhoenix.Form struct. :method ( String.t/0 ) - The http method to associate with the form. Defaults to post for creates, and put for everything else. :exclude_fields_if_empty - These fields will be ignored if they are empty strings. This list of fields supports dead view forms. When a form is submitted from dead view empty fields are submitted as empty strings. This is problematic for fields that allow_nil or those that have default values. Any additional options will be passed to the underlying call to Ash.Changeset.for_update/4 . This means you can set things like the tenant/actor. These will be retained, and provided again when Form.submit/3 is called.","ref":"AshPhoenix.Form.html#for_update/3","title":"AshPhoenix.Form.for_update/3","type":"function"},{"doc":"Gets the form at the specified path","ref":"AshPhoenix.Form.html#get_form/2","title":"AshPhoenix.Form.get_form/2","type":"function"},{"doc":"Returns true if a given form path exists in the form","ref":"AshPhoenix.Form.html#has_form?/2","title":"AshPhoenix.Form.has_form?/2","type":"function"},{"doc":"Returns the hidden fields for a form as a keyword list","ref":"AshPhoenix.Form.html#hidden_fields/1","title":"AshPhoenix.Form.hidden_fields/1","type":"function"},{"doc":"Toggles the form to be ignored or not ignored. To set this manually in an html form, use the field :_ignored and set it to the string &quot;true&quot;. Any other value will not result in the form being ignored.","ref":"AshPhoenix.Form.html#ignore/1","title":"AshPhoenix.Form.ignore/1","type":"function"},{"doc":"Returns true if the form is ignored","ref":"AshPhoenix.Form.html#ignored?/1","title":"AshPhoenix.Form.ignored?/1","type":"function"},{"doc":"Merge the new options with the saved options on a form. See update_options/2 for more.","ref":"AshPhoenix.Form.html#merge_options/2","title":"AshPhoenix.Form.merge_options/2","type":"function"},{"doc":"Returns the parameters from the form that would be submitted to the action. This can be useful if you want to get the parameters and manipulate them/build a custom changeset afterwards.","ref":"AshPhoenix.Form.html#params/2","title":"AshPhoenix.Form.params/2","type":"function"},{"doc":"A utility for parsing paths of nested forms in query encoded format. For example: parse_path! ( form , &quot; post [ comments ] [ 0 ] [ sub_comments ] [ 0 ] ) [ :comments , 0 , :sub_comments , 0 ]","ref":"AshPhoenix.Form.html#parse_path!/2","title":"AshPhoenix.Form.parse_path!/2","type":"function"},{"doc":"Removes a form at the provided path. See add_form/3 for more information on the path argument. If you are not using liveview, and you want to support removing forms that were created based on the data option from the browser, you'll need to include in the form submission a custom list of strings to remove, and then manually iterate over them in your controller, for example: Enum . reduce ( removed_form_paths , form , &amp; AshPhoenix.Form . remove_form ( &amp;2 , &amp;1 ) ) :validate? ( boolean/0 ) - Validates the new full form. The default value is true . :validate_opts ( term/0 ) - Options to pass to validate . Only used if validate? is set to true (the default) The default value is [] .","ref":"AshPhoenix.Form.html#remove_form/3","title":"AshPhoenix.Form.remove_form/3","type":"function"},{"doc":"Sets the data of the form, in addition to the data of the underlying source, if applicable. Queries do not track data (because that wouldn't make sense), so this will not update the data for read actions","ref":"AshPhoenix.Form.html#set_data/2","title":"AshPhoenix.Form.set_data/2","type":"function"},{"doc":"Same as submit/2 , but raises an error if the submission fails.","ref":"AshPhoenix.Form.html#submit!/2","title":"AshPhoenix.Form.submit!/2","type":"function"},{"doc":"Submits the form by calling the appropriate function on the configured api. For example, a form created with for_update/3 will call api.update(changeset) , where changeset is the result of passing the Form.params/3 into Ash.Changeset.for_update/4 . If the submission returns an error, the resulting form can simply be rerendered. Any nested errors will be passed down to the corresponding form for that input. Options: :force? ( boolean/0 ) - Submit the form even if it is invalid in its current state. The default value is false . :api_opts ( keyword/0 ) - Opts to pass to the call to the api when submitting The default value is [] . :errors ( boolean/0 ) - Wether or not to show errors after submitting. The default value is true . :override_params ( term/0 ) - If specified, then the params are not extracted from the form. How this different from params : providing params is simply results in calling validate(form, params) before proceeding. The values that are passed into the action are then extracted from the form using params/2 . With override_params , the form is not validated again, and the override_params are passed directly into the action. :params ( term/0 ) - If specified, validate/3 is called with the new params before submitting the form. This is a shortcut to avoid needing to explicitly validate before every submit. For example: form |&gt; AshPhoenix.Form . validate ( params ) |&gt; AshPhoenix.Form . submit ( ) Is the same as: form |&gt; AshPhoenix.Form . submit ( params : params ) :read_one? ( boolean/0 ) - If submitting a read form, a single result will be returned (via read_one) instead of a list of results. Ignored for non-read forms. The default value is false . :before_submit (function of arity 1) - A function to apply to the source (changeset or query) just before submitting the action. Must return the modified changeset.","ref":"AshPhoenix.Form.html#submit/2","title":"AshPhoenix.Form.submit/2","type":"function"},{"doc":"Mark a field or fields as touched To mark nested fields as touched use with update_form/4 or update_forms_at_path/4","ref":"AshPhoenix.Form.html#touch/2","title":"AshPhoenix.Form.touch/2","type":"function"},{"doc":"Updates the form at the provided path using the given function. Marks all forms along the path as touched by default. To prevent it, provide mark_as_touched?: false . This can be useful if you have a button that should modify a nested form in some way, for example.","ref":"AshPhoenix.Form.html#update_form/4","title":"AshPhoenix.Form.update_form/4","type":"function"},{"doc":"Updates the list of forms matching a given path. Does not validate that the path points at a single form like update_form/4 . Additionally, if it gets to a list of child forms and the next part of the path is not an integer, it will update all of the forms at that path.","ref":"AshPhoenix.Form.html#update_forms_at_path/4","title":"AshPhoenix.Form.update_forms_at_path/4","type":"function"},{"doc":"Update the saved options on a form. When a form is created, options like actor and authorize? are stored in the opts key. If you have a case where these options change over time, for example a select box that determines the actor, use this function to override those opts. You may want to validate again after this has been changed if it can change the results of your form validation.","ref":"AshPhoenix.Form.html#update_options/2","title":"AshPhoenix.Form.update_options/2","type":"function"},{"doc":"Validates the parameters against the form. Options: :errors ( boolean/0 ) - Set to false to hide errors after validation The default value is true .","ref":"AshPhoenix.Form.html#validate/3","title":"AshPhoenix.Form.validate/3","type":"function"},{"doc":"Gets the value for a given field in the form.","ref":"AshPhoenix.Form.html#value/2","title":"AshPhoenix.Form.value/2","type":"function"},{"doc":"","ref":"AshPhoenix.Form.html#t:t/0","title":"AshPhoenix.Form.t/0","type":"type"},{"doc":"A tool to automatically generate available nested forms based on a resource and action. To use this, specify forms: [auto?: true] when creating the form. Keep in mind, you can always specify these manually when creating a form by simply specifying the forms option. There are two things that this builds forms for: Attributes/arguments who's type is an embedded resource. Arguments that have a corresponding change manage_relationship(..) configured. For more on relationships see the documentation for Ash.Changeset.manage_relationship/4 . When building forms, you can switch on the action type and/or resource of the form, in order to have different fields depending on the form. For example, if you have a simple relationship called :comments with on_match: :update and on_no_match: :create , there are two types of forms that can be in inputs_for(form, :comments) . In which case you may have something like this: &lt; % = for comment_form &lt;- inputs_for ( f , :comments ) do % &gt; &lt; % = hidden_inputs_for ( comment_form ) % &gt; &lt; % = if comment_form . source . type == :create do % &gt; &lt; % = text_input comment_form , :text % &gt; &lt; % = text_input comment_form , :on_create_field % &gt; &lt; % else % &gt; &lt; % = text_input comment_form , :text % &gt; &lt; % = text_input comment_form , :on_update_field % &gt; &lt; % end % &gt; &lt; button phx - click = &quot;remove_form&quot; phx - value - path = &quot;&lt;%= comment_form.name %&gt;&quot; &gt; Add Comment &lt; / button &gt; &lt; button phx - click = &quot;add_form&quot; phx - value - path = &quot;&lt;%= comment_form.name %&gt;&quot; &gt; Add Comment &lt; / button &gt; &lt; % end % &gt; This also applies to adding forms of different types manually. For instance, if you had a &quot;search&quot; field to allow them to search for a record (e.g in a liveview), and you had an on_lookup read action, you could render a search form for that read action, and once they've selected a record, you could render the fields to update that record (in the case of on_lookup: :relate_and_update configurations). Options :relationship_fetcher ( term/0 ) - A two argument function that receives the parent data, the relationship to fetch. The default simply fetches the relationship value, and if it isn't loaded, it uses [] or nil . :sparse_lists? ( boolean/0 ) - Sets all list type forms to sparse?: true by default. Has no effect on forms derived for embedded resources. The default value is false . :include_non_map_types? ( boolean/0 ) - Creates form for non map or array of map type inputs The default value is false . Special Considerations on_lookup: :relate_and_update For on_lookup: :relate_and_update configurations, the &quot;read&quot; form for that relationship will use the appropriate read action. However, you may also want to include the relevant fields for the update that would subsequently occur. To that end, a special nested form called :_update is created, that uses an empty instance of that resource as the base of its changeset. This may require some manual manipulation of that data before rendering the relevant form because it assumes all the default values. To solve for this, if you are using liveview, you could actually look up the record using the input from the read action, and then use AshPhoenix.Form.update_form/3 to set that looked up record as the data of the _update form. Many to Many Relationships In the case that a manage_change option points to a join relationship, that form is presented via a special nested form called _join . So the first form in inputs_for(form, :relationship) would be for the destination, and then inside of that you could say inputs_for(nested_form, :_join) . The parameters are merged together during submission.","ref":"AshPhoenix.Form.Auto.html","title":"AshPhoenix.Form.Auto","type":"module"},{"doc":"","ref":"AshPhoenix.Form.Auto.html#auto/3","title":"AshPhoenix.Form.Auto.auto/3","type":"function"},{"doc":"","ref":"AshPhoenix.Form.Auto.html#embedded/3","title":"AshPhoenix.Form.Auto.embedded/3","type":"function"},{"doc":"","ref":"AshPhoenix.Form.Auto.html#related/3","title":"AshPhoenix.Form.Auto.related/3","type":"function"},{"doc":"A protocol for allowing errors to be rendered into a form. To implement, define a to_form_error/1 and return a single error or list of errors of the following shape: {:field_name, message, replacements} Replacements is a keyword list to allow for translations, by extracting out the constants like numbers from the message.","ref":"AshPhoenix.FormData.Error.html","title":"AshPhoenix.FormData.Error","type":"protocol"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#to_form_error/1","title":"AshPhoenix.FormData.Error.to_form_error/1","type":"function"},{"doc":"","ref":"AshPhoenix.FormData.Error.html#t:t/0","title":"AshPhoenix.FormData.Error.t/0","type":"type"},{"doc":"Utilities for keeping ash query results up to date in a live view.","ref":"AshPhoenix.LiveView.html","title":"AshPhoenix.LiveView","type":"module"},{"doc":"","ref":"AshPhoenix.LiveView.html#can_link_to_page?/2","title":"AshPhoenix.LiveView.can_link_to_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#change_page/3","title":"AshPhoenix.LiveView.change_page/3","type":"function"},{"doc":"Incorporates an Ash.Notifier.Notification into the query results, based on the liveness configuration. You will want to match on receiving a notification from Ash, and the easiest way to do that is to match on the payload like so: @impl true def handle_info ( %{ topic : topic , payload : % Ash.Notifier.Notification { } } , socket ) do { :noreply , handle_live ( socket , topic , [ :query1 , :query2 , :query3 ] ) } end Feel free to intercept notifications and do your own logic to respond to events. Ultimately, all that matters is that you also call handle_live/3 if you want it to update your query results. The assign or list of assigns passed as the third argument must be the same names passed into keep_live . If you only want some queries to update based on some events, you can define multiple matches on events, and only call handle_live/3 with the assigns that should be updated for that notification.","ref":"AshPhoenix.LiveView.html#handle_live/4","title":"AshPhoenix.LiveView.handle_live/4","type":"function"},{"doc":"Runs the callback, and stores the information required to keep it live in the socket assigns. The data will be assigned to the provided key, e.g keep_live(socket, :me, ...) would assign the results to :me (accessed as @me in the template). Additionally, you'll need to define a handle_info/2 callback for your liveview to receive any notifications, and pass that notification into handle_live/3 . See handle_live/3 for more. Important The logic for handling events to keep data live is currently very limited. It will simply rerun the query every time. To this end, you should feel free to intercept individual events and handle them yourself for more optimized liveness. Pagination To make paginated views convenient, as well as making it possible to keep those views live, Ash does not simply rerun the query when it gets an update, as that could involve shuffling the records around on the page. Eventually this will be configurable, but for now, Ash simply adjusts the query to only include the records that are on the page. If a record would be removed from a page due to a data change, it will simply be left there. For the best performance, use keyset pagination. If you need the ability to jump to a page by number, you'll want to use offset pagination, but keep in mind that it performs worse on large tables. To support this, accept a second parameter to your callback function, which will be the options to use in page_opts Options: :subscribe - A topic or list of topics that should cause this data to update. :refetch? ( boolean/0 ) - A boolean flag indicating whether a refetch is allowed to happen. Defaults to true :after_fetch ( term/0 ) - A two argument function that takes the results, and the socket, and returns the new socket. Can be used to set assigns based on the result of the query. :results - For list and page queries, by default the records shown are never changed (unless the page changes) The default value is :keep . :load_until_connected? ( boolean/0 ) - If the socket is not connected, then the value of the provided assign is set to :loading . Has no effect if initial is provided. :initial ( term/0 ) - Results to use instead of running the query immediately. :api ( atom/0 ) - For paginated views, in order to use change_page/3 , you must set the Api to use for pagination :refetch_interval ( non_neg_integer/0 ) - An interval (in ms) to periodically refetch the query :refetch_window ( non_neg_integer/0 ) - The minimum time (in ms) between refetches, including refetches caused by notifications. A great way to get readable millisecond values is to use the functions in erlang's :timer module, like :timer.hours/1 , :timer.minutes/1 , and :timer.seconds/1 refetch_interval If this option is set, a message is sent as {:refetch, assign_name, opts} on that interval. You can then match on that event, like so: def handle_info ( { :refetch , assign , opts } , socket ) do { :noreply , handle_live ( socket , :refetch , assign , opts ) } end This is the equivalent of :timer.send_interval(interval, {:refetch, assign, opts}) , so feel free to roll your own solution if you have complex refetching requirements. refetch_window Normally, when a pubsub message is received the query is rerun. This option will cause the query to wait at least this amount of time before doing a refetch. This is accomplished with Process.send_after/4 , and recording the last time each query was refetched. For example if a refetch happens at time 0 , and the refetch_window is 10,000 ms, we would refetch, and record the time. Then if another refetch should happen 5,000 ms later, we would look and see that we need to wait another 5,000ms. So we use Process.send_after/4 to send a {:refetch, assign, opts} message in 5,000ms. The time that a refetch was requested is tracked, so if the data has since been refetched, it won't be refetched again. Future Plans One interesting thing here is that, given that we know the scope of data that a resource cares about, we should be able to make optimizations to this code, to support partial refetches, or even just updating the data directly. However, this will need to be carefully considered, as the risks involve showing users data they could be unauthorized to see, or having state in the socket that is inconsistent.","ref":"AshPhoenix.LiveView.html#keep_live/4","title":"AshPhoenix.LiveView.keep_live/4","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#last_page/1","title":"AshPhoenix.LiveView.last_page/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#next_page?/1","title":"AshPhoenix.LiveView.next_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#on_page?/2","title":"AshPhoenix.LiveView.on_page?/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_from_params/3","title":"AshPhoenix.LiveView.page_from_params/3","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_link_params/2","title":"AshPhoenix.LiveView.page_link_params/2","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_number/1","title":"AshPhoenix.LiveView.page_number/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#page_params/1","title":"AshPhoenix.LiveView.page_params/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#prev_page?/1","title":"AshPhoenix.LiveView.prev_page?/1","type":"function"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assign/0","title":"AshPhoenix.LiveView.assign/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:assigns/0","title":"AshPhoenix.LiveView.assigns/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback/0","title":"AshPhoenix.LiveView.callback/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:callback_result/0","title":"AshPhoenix.LiveView.callback_result/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:liveness_options/0","title":"AshPhoenix.LiveView.liveness_options/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:socket/0","title":"AshPhoenix.LiveView.socket/0","type":"type"},{"doc":"","ref":"AshPhoenix.LiveView.html#t:topic/0","title":"AshPhoenix.LiveView.topic/0","type":"type"},{"doc":"This is a basic plug that loads the current tenant assign from a given value set on subdomain. This was copied from Triplex.SubdomainPlug , here: https://github.com/ateliware/triplex/blob/master/lib/triplex/plugs/subdomain_plug.ex Options: :endpoint ( atom/0 ) - Required. The endpoint that the plug is in, used for deterining the host :assign ( atom/0 ) - The key to use when assigning the current tenant The default value is :current_tenant . :handle_subdomain - An mfa to call with the conn and a subdomain value. Can be used to do something like fetch the current user given the tenant. Must return the new conn. To plug it on your router, you can use: plug AshPhoenix.SubdomainPlug , endpoint : MyApp.Endpoint An additional helper here can be used for determining the host in your liveview, and/or using the host that was already assigned to the conn. For example: def handle_params ( params , uri , socket ) do socket = assign_new ( socket , :current_tenant , fn -&gt; AshPhoenix.SubdomainPlug . live_tenant ( socket , uri ) end ) socket = assign_new ( socket , :current_organization , fn -&gt; if socket . assigns [ :current_tenant ] do MyApp.Accounts.Api . get! ( MyApp.Accounts.Organization , subdomain : socket . assigns [ :current_tenant ] ) end end ) { :noreply , socket } end","ref":"AshPhoenix.SubdomainPlug.html","title":"AshPhoenix.SubdomainPlug","type":"module"},{"doc":"","ref":"AshPhoenix.SubdomainPlug.html#live_tenant/2","title":"AshPhoenix.SubdomainPlug.live_tenant/2","type":"function"},{"doc":"Raised when an invalid path is used to find, update or remove a form","ref":"AshPhoenix.Form.InvalidPath.html","title":"AshPhoenix.Form.InvalidPath","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.InvalidPath.html#message/1","title":"AshPhoenix.Form.InvalidPath.message/1","type":"function"},{"doc":"Raised when a form action should happen but no action of the appropriate type has been configured","ref":"AshPhoenix.Form.NoActionConfigured.html","title":"AshPhoenix.Form.NoActionConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoActionConfigured.html#message/1","title":"AshPhoenix.Form.NoActionConfigured.message/1","type":"function"},{"doc":"Raised when a data needed to be used but the required data was not loaded","ref":"AshPhoenix.Form.NoDataLoaded.html","title":"AshPhoenix.Form.NoDataLoaded","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoDataLoaded.html#message/1","title":"AshPhoenix.Form.NoDataLoaded.message/1","type":"function"},{"doc":"Raised when attempting to refer to a form but no nested form with that name was configured.","ref":"AshPhoenix.Form.NoFormConfigured.html","title":"AshPhoenix.Form.NoFormConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoFormConfigured.html#message/1","title":"AshPhoenix.Form.NoFormConfigured.message/1","type":"function"},{"doc":"Raised when a form needed to be constructed but the resource for that form could not be determined","ref":"AshPhoenix.Form.NoResourceConfigured.html","title":"AshPhoenix.Form.NoResourceConfigured","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AshPhoenix.Form.NoResourceConfigured.html#message/1","title":"AshPhoenix.Form.NoResourceConfigured.message/1","type":"function"},{"doc":"This documentation is best viewed at ash-hq.org","ref":"getting-started-with-ash-and-phoenix.html","title":"Getting Started With Ash And Phoenix","type":"extras"},{"doc":"This is designed to be a quick start guide for Ash with Phoenix. Familiarity with Phoenix and LiveView are not necessary, but would certainly be helpful.","ref":"getting-started-with-ash-and-phoenix.html#who-is-this-for","title":"Getting Started With Ash And Phoenix - Who is This For?","type":"extras"},{"doc":"In this guide we will: Create a new Phoenix project Setup Ash, AshPhoenix and AshPostgres as dependencies Create a basic Blog.Post resource Create and migrate the database Learn how to interact with your resource Integrate a minimal Phoenix LiveView with Ash","ref":"getting-started-with-ash-and-phoenix.html#goals","title":"Getting Started With Ash And Phoenix - Goals","type":"extras"},{"doc":"Install Elixir Phoenix - Up and Running Guide Philosophy Guide","ref":"getting-started-with-ash-and-phoenix.html#things-you-may-want-to-read-first","title":"Getting Started With Ash And Phoenix - Things You May Want to Read First","type":"extras"},{"doc":"If you want to follow along yourself, you will need the following things: Elixir (1.12 or later) and Erlang (22 or later) installed PostgreSQL installed A text editor A terminal to run the examples","ref":"getting-started-with-ash-and-phoenix.html#requirements","title":"Getting Started With Ash And Phoenix - Requirements","type":"extras"},{"doc":"Create a New Phoenix Project This section is based on the Phoenix installation docs . For more details go there. First we need to install the Phoenix project generator, then we'll run the generator to create our new project. NOTE: DO NOT run mix ecto.create , (as it asks you to) we will do this the Ash way later. # install Phoenix project generator $ mix archive.install hex phx_new # generate Phoenix project $ mix phx.new my_ash_phoenix_app # cd into project $ cd my_ash_phoenix_app Add Dependencies We now need to add Ash, AshPhoenix and AshPostgres to our Phoenix project. We need to add the dependencies to the deps function in our mix.exs . We'll also need to add dependencies to our .formatter.exs to ensure consistent formatting when using mix format . # mix.exs def deps do [ # use `mix hex.info &lt;library_name&gt;` to get the latest versions of each dependency, for example, `mix hex.info phoenix` { :phoenix , &quot;~&gt; x.x&quot; } , # ... { :ash , &quot;~&gt; x.x&quot; } , { :ash_postgres , &quot;~&gt; x.x&quot; } , { :ash_phoenix , &quot;~&gt; x.x&quot; } ] end # .formatter.exs [ import_deps : [ :ecto , :phoenix , :ash , :ash_phoenix , :ash_postgres ] , inputs : [ &quot;*.{ex,exs}&quot; , &quot;priv/*/seeds.exs&quot; , &quot;{config,lib,test}/**/*.{ex,exs}&quot; ] , subdirectories : [ &quot;priv/*/migrations&quot; ] ] Now in the terminal install these new dependencies. $ mix deps.get Use AshPostgres.Repo We need to swap Ecto.Repo for AshPostgres.Repo . AshPostgres.Repo enriches your repo with additional AshPostgres specific behaviour, but is essentially a thin wrapper around Ecto.Repo . To use AshPostgres.Repo change your repo module to look like this: # lib/my_ash_phoenix_app/repo.ex defmodule MyAshPhoenixApp.Repo do use AshPostgres.Repo , otp_app : :my_ash_phoenix_app # Installs Postgres extensions that ash commonly uses def installed_extensions do [ &quot;uuid-ossp&quot; , &quot;citext&quot; ] end end Edit Config We need to specify the Ash APIs that our application uses and some config for backwards compatibility that will be removed in the next major release. Add this to your config: # config/config.exs import Config # For backwards compatibility, the following configuration is required. # see https://ash-hq.org/docs/guides/ash/latest/get-started#temporary-config for more details config :ash , :use_all_identities_in_manage_relationship? , false config :my_ash_phoenix_app , ash_apis : [ MyAshPhoenixApp.Blog ] If you have already compiled your app, you may get errors recompiling it after adding this config. To solve for that, run the following command: mix deps . compile ash -- force &amp;&amp; MIX_ENV = test mix deps . compile ash -- force Create the API and Registry An Ash API can be thought of as a Bounded Context in Domain Driven Design terms and can seen as analogous to a Phoenix context. Put simply, its a way of grouping related resources together. In our case our API will be called MyAshPhoenixApp.Blog . An Ash API points to an Ash registry. The registry in our case will be MyAshPhoenixApp.Blog.Registry An Ash registry points to one or more resources. In our case we will only have a single resource MyAshPhoenixApp.Blog.Post . We'll be taking a deeper look into that in the next section. For now take a look at the Blog API and the Blog.Registry : # lib/my_ash_phoenix_app/blog/blog.ex defmodule MyAshPhoenixApp.Blog do use Ash.Api resources do registry MyAshPhoenixApp.Blog.Registry end end # lib/my_ash_phoenix_app/blog/registry.ex defmodule MyAshPhoenixApp.Blog.Registry do use Ash.Registry , extensions : [ # This extension adds helpful compile time validations Ash.Registry.ResourceValidations ] entries do entry MyAshPhoenixApp.Blog.Post end end","ref":"getting-started-with-ash-and-phoenix.html#setup","title":"Getting Started With Ash And Phoenix - Setup","type":"extras"},{"doc":"Creating the Post Resource A resource is a central concept in Ash. In short, a resource is a domain model object in your system. A resource defines the data it holds and defines the actions that can operate on that data. It's convention to place all the resource in their own resources folder. So when we create Post we will place it in lib/my_ash_phoenix_project/blog/resources/post.ex . So the structure after making the resource should look like so: lib / ├ ─ my_ash_phoenix_app / │ ├ ─ blog / │ │ ├ ─ blog . ex │ │ ├ ─ registry . ex │ │ ├ ─ resources / │ │ │ ├ ─ post . ex Below is the resource module. Read the comments carefully, every line is explained: # lib/my_ash_phoenix_app/blog/resources/post.ex defmodule MyAshPhoenixApp.Blog.Post do # Using Ash.Resource turns this module into an Ash resource. use Ash.Resource , # Tells Ash you want this resource to store its data in Postgres. data_layer : AshPostgres.DataLayer # The Postgres keyword is specific to the AshPostgres module. postgres do # Tells Postgres what to call the table table &quot;posts&quot; # Tells Ash how to interface with the Postgres table repo MyAshPhoenixApp.Repo end # Defines convenience methods for # interacting with the resource programmatically. code_interface do define_for MyAshPhoenixApp.Blog define :create , action : :create define :read_all , action : :read define :update , action : :update define :destroy , action : :destroy define :get_by_id , args : [ :id ] , action : :by_id end actions do # Exposes default built in actions to manage the resource defaults [ :create , :read , :update , :destroy ] # Defines custom read action which fetches post by id. read :by_id do # This action has one argument :id of type :uuid argument :id , :uuid , allow_nil? : false # Tells us we expect this action to return a single result get? true # Filters the `:id` given in the argument # against the `id` of each element in the resource filter expr ( id == ^ arg ( :id ) ) end end # Attributes are simple pieces of data that exist in your resource attributes do # Add an autogenerated UUID primary key called `:id`. uuid_primary_key :id # Add a string type attribute called `:title` attribute :title , :string do # We don&#39;t want the title to ever be `nil` allow_nil? false end # Add a string type attribute called `:content` # If allow_nil? is not specified, then content can be nil attribute :content , :string end end Creating and Migrating the Database We have specified the resource in Ash. But we have yet to create it in our data layer (in our case Postgres). First we need to create our database: $ mix ash_postgres.create The database for MyAshPhoenixApp.Repo has been created Now we need to populate our database. We do this by generating and performing a migration. We can use a generator to produce a migration for us. Ash can deduce what needs to go into the migration and do the hard work for us, to do this use the command below: $ mix ash_postgres.generate_migrations --name initial_migration # ... don&#39;t worry about other files it creates Generating Migrations: * creating priv/repo/migrations/20230208045101_initial_migration.exs Here is the migration file commented in detail: # priv/repo/migrations/20230208045101_initial_migration.exs defmodule MyAshPhoenixApp.Repo.Migrations.InitialMigration do use Ecto.Migration # This function runs when migrating forward def up do # Creates the `:posts` table create table ( :posts , primary_key : false ) do # Adds primary key attribute `:id` of type `:uuid` # null values are not allowed add :id , :uuid , null : false , default : fragment ( &quot;uuid_generate_v4()&quot; ) , primary_key : true # Adds attribute `:title` of type `:text`, null values are not allowed add :title , :text , null : false # Adds attribute `:content` of type `:text`, null values are allowed add :content , :text end end # This is the function that runs if you want to rollback the migration. def down do # Deletes the `:posts` table drop table ( :posts ) end end We can run the up/0 function which will perform the desired operations on the Postgres database. We do this with the migrate command: $ mix ash_postgres.migrate In case you want to drop the database and start over again during development you can use mix ash_postgres.drop followed by mix ash_postgres.create and mix ash_postgres.migrate .","ref":"getting-started-with-ash-and-phoenix.html#creating-resources","title":"Getting Started With Ash And Phoenix - Creating Resources","type":"extras"},{"doc":"All interaction with your resource attributes always occur through an action . In our resource we are using the default actions for :create, :read, :update, :destroy along with a custom action :by_id . :create and :update and :destroy actions require a changeset. Ash changesets are conceptually similar to Ecto changesets . They're data structures which represent an intended change to an Ash resource and provide validation. The :read action takes a query instead of a changeset. Below is the most verbose way of calling your resource. All other ways of interaction are some kind of shorthand of these. This means at some point a changeset is being created and passed to the API, even if it's encapsulated within another function. # create post new_post = MyAshPhoenixApp.Blog.Post |&gt; Ash.Changeset . for_create ( :create , %{ title : &quot;hello world&quot; } ) |&gt; MyAshPhoenixApp.Blog . create! ( ) # read all posts MyAshPhoenixApp.Blog.Post |&gt; Ash.Query . for_read ( :read ) |&gt; MyAshPhoenixApp.Blog . read! ( ) # get single post by id MyAshPhoenixApp.Blog.Post |&gt; Ash.Query . for_read ( :by_id , %{ id : new_post . id } ) |&gt; MyAshPhoenixApp.Blog . read_one! ( ) # update post updated_post = new_post |&gt; Ash.Changeset . for_update ( :update , %{ content : &quot;hello to you too!&quot; } ) |&gt; MyAshPhoenixApp.Blog . update! ( ) # delete post new_post |&gt; Ash.Changeset . for_destroy ( :destroy ) |&gt; MyAshPhoenixApp.Blog . destroy! ( ) As stated above, this is verbose so Ash has a built in shortcut - The code_interface . You may notice this has already been done in your Post resource. Here it is again with more explanation: code_interface do # defines the API this resource should be called from define_for MyAshPhoenixApp.Blog # defining function Post.create/2 it calls the :create action define :create , action : :create # defining function Post.read_all/2 it calls the :read action define :read_all , action : :read # defining function Post.update/2 it calls the :update action define :update , action : :update # defining function Post.destroy/2 it calls the :destroy action define :destroy , action : :destroy # defining function Post.get_by_id/2 # it calls the :by_id action with the argument :id define :get_by_id , args : [ :id ] , action : :by_id end Note: The function name doesn't have to match the action name in any way. You could also write: define :make , action : :create That's perfectly valid and could be called via Blog.make/2 . Now we can call our resource like so: # create post new_post = MyAshPhoenixApp.Blog.Post . create! ( %{ title : &quot;hello world&quot; } ) # read post MyAshPhoenixApp.Blog.Post . read_all! ( ) # get post by id MyAshPhoenixApp.Blog.Post . get_by_id! ( new_post . id ) # update post updated_post = MyAshPhoenixApp.Blog.Post . update! ( new_post , %{ content : &quot;hello to you too!&quot; } ) # delete post MyAshPhoenixApp.Blog.Post . destroy! ( updated_post ) Now isn't that more convenient? Note: All functions that interact with an Ash resource have a safe and unsafe version. For example there are two create functions create/2 and create!/2 . create/2 returns {:ok, resource} or {:error, reason} . create!/2 will return just the resource on success and will raise an error on failure.","ref":"getting-started-with-ash-and-phoenix.html#interacting-with-your-resources","title":"Getting Started With Ash And Phoenix - Interacting with your Resources","type":"extras"},{"doc":"Now we know how to interact with our resource, let's connect it to a simple Phoenix LiveView. Here is the LiveView below: # lib/my_ash_phoenix_app_web/example_live_view.ex defmodule MyAshPhoenixAppWeb.ExampleLiveView do use MyAshPhoenixAppWeb , :live_view import Phoenix.HTML.Form alias MyAshPhoenixApp.Blog.Post def render ( assigns ) do ~H&quot;&quot;&quot; &lt;h2&gt;Posts&lt;/h2&gt; &lt;div&gt; &lt;%= for post &lt;- @posts do %&gt; &lt;div&gt; &lt;div&gt;&lt;%= post.title %&gt;&lt;/div&gt; &lt;div&gt;&lt;%= if Map.get(post, :content), do: post.content, else: &quot;&quot; %&gt;&lt;/div&gt; &lt;button phx-click=&quot;delete_post&quot; phx-value-post-id={post.id}&gt;delete&lt;/button&gt; &lt;/div&gt; &lt;% end %&gt; &lt;/div&gt; &lt;h2&gt;Create Post&lt;/h2&gt; &lt;.form let={f} for={@create_form} phx-submit=&quot;create_post&quot;&gt; &lt;%= text_input f, :title, placeholder: &quot;input title&quot; %&gt; &lt;%= submit &quot;create&quot; %&gt; &lt;/.form&gt; &lt;h2&gt;Update Post&lt;/h2&gt; &lt;.form let={f} for={@update_form} phx-submit=&quot;update_post&quot;&gt; &lt;%= label f, :&quot;post name&quot; %&gt; &lt;%= select f, :post_id, @post_selector %&gt; &lt;%= text_input f, :content, value: &quot;&quot;, placeholder: &quot;input content&quot; %&gt; &lt;%= submit &quot;update&quot; %&gt; &lt;/.form&gt; &quot;&quot;&quot; end def mount ( _params , _session , socket ) do posts = Post . read_all! ( ) socket = assign ( socket , posts : posts , post_selector : post_selector ( posts ) , # the `to_form/1` calls below are for liveview 0.18.12+. For earlier versions, remove those calls create_form : AshPhoenix.Form . for_create ( Post , :create ) |&gt; to_form ( ) , update_form : AshPhoenix.Form . for_update ( List . first ( posts , % Post { } ) , :update ) |&gt; to_form ( ) ) { :ok , socket } end def handle_event ( &quot;delete_post&quot; , %{ &quot;post-id&quot; =&gt; post_id } , socket ) do post_id |&gt; Post . get_by_id! ( ) |&gt; Post . destroy! ( ) posts = Post . read_all! ( ) { :noreply , assign ( socket , posts : posts , post_selector : post_selector ( posts ) ) } end def handle_event ( &quot;create_post&quot; , %{ &quot;form&quot; =&gt; %{ &quot;title&quot; =&gt; title } } , socket ) do Post . create ( %{ title : title } ) posts = Post . read_all! ( ) { :noreply , assign ( socket , posts : posts , post_selector : post_selector ( posts ) ) } end def handle_event ( &quot;update_post&quot; , %{ &quot;form&quot; =&gt; form_params } , socket ) do %{ &quot;post_id&quot; =&gt; post_id , &quot;content&quot; =&gt; content } = form_params post_id |&gt; Post . get_by_id! ( ) |&gt; Post . update! ( %{ content : content } ) posts = Post . read_all! ( ) { :noreply , assign ( socket , posts : posts , post_selector : post_selector ( posts ) ) } end defp post_selector ( posts ) do for post &lt;- posts do { post . title , post . id } end end end Don't forget to add the LiveView to your router. # lib/my_ash_phoenix_web_app/ scope &quot;/&quot; , MyAshPhoenixAppWeb do # ... live &quot;/posts&quot; , ExampleLiveView end All being well you should be able to load up what we have just created on http://localhost:4000/posts . You can see how using functions created by our code_interface makes it easy to integrate Ash with Phoenix. You may also notice this is the first time we've used the AshPhoenix library. The AshPhoenix library contains utilities to help Ash integrate with Phoenix and LiveView Seamlessly. One of these utilities is AshPhoenix.Form which can automatically produce changesets to be used in the forms. That's it for this guide. We've gone from 0 to a fully working Phoenix App using Ash. To get a closer look, see the accompanying repo here .","ref":"getting-started-with-ash-and-phoenix.html#connecting-your-resource-to-a-phoenix-liveview","title":"Getting Started With Ash And Phoenix - Connecting your Resource to a Phoenix LiveView","type":"extras"},{"doc":"We are really just scratching the surface of what can be done in Ash. Look below for what to look at next. Continue Learning There's a few places you can go to learn more about how to use ash: Read more about how to query the data in your resources - Ash.Query Dig deeper into actions. Study resource relationship management Ash Authentication &amp; Ash Authentication Phoenix See the power Ash can bring to your web app or API. Get authentication working in minutes . Add an API (or two) Check out the AshJsonApi and AshGraphql extensions to effortlessly build APIs around your resources.","ref":"getting-started-with-ash-and-phoenix.html#where-to-next","title":"Getting Started With Ash And Phoenix - Where to Next?","type":"extras"},{"doc":"The AshPhoenix plugin adds lots of helpers for working with Phoenix Liveview (and regular views). {:ash_phoenix, &quot;~&gt; 1.2.15&quot;}","ref":"working-with-phoenix.html","title":"Working With Phoenix","type":"extras"},{"doc":"AshPhoenix.Form - A form data structure for using resource actions with phoenix forms AshPhoenix.Form.Auto - Tools to automatically determine nested form structures based on calls manage_relationship for an action. AshPhoenix.FilterForm - A form data structure for building filter statements AshPhoenix.LiveView - Helpers for querying data and integrating changes AshPhoenix.SubdomainPlug - A plug to determine a tenant using subdomains for multitenancy AshPhoenix.FormData.Error - A protocol to allow errors to be rendered in forms Phoenix.HTML.Safe implementations for Ash.CiString and Ash.NotLoaded","ref":"working-with-phoenix.html#whats-in-the-box","title":"Working With Phoenix - Whats in the box?","type":"extras"}]